%
%                              Copyright 2008 Cleimar Jos Salvador, 
%						                      Diego da Silva de Medeiros, 
%						                      Fabrcio Emydio da Silva, 
%						                      Patrick Hedlund Rosa, 
%						                      Marcos Moecke, 
%						                      Mario de Noronha Neto
%
%
%    This file is part of Edge2javaTX.
%
%    Edge2javaTX is free software: you can redistribute it and/or modify
%    it under the terms of the GNU General Public License as published by
%    the Free Software Foundation, either version 3 of the License, or
%    (at your option) any later version.
%
%    Edge2javaTX is distributed in the hope that it will be useful,
%    but WITHOUT ANY WARRANTY; without even the implied warranty of
%    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%    GNU General Public License for more details.
%
%    You should have received a copy of the GNU General Public License
%    along with Edge2javaTX. If not, see <http://www.gnu.org/licenses/>.
%

%-------------------------------------------------------------------------%
%
%    Centro Federal de Educao Tecnolgica de Santa Catarina - CEFET
%                         Unidade So Jos
%      Curso Superior de Tecnologia em Sistemas de Telecomunicaes
%
%
%
%
%    Transmisso de imagens para uma aplicao java numa unidade mvel
%                    utilizando a tecnologia EDGE
%
%
%                                                    Cleimar Jos Salvador
%                                               Diego da Silva de Medeiros
%                                                 Fabrcio Emydio da Silva
%                                                     Patrick Hedlund Rosa
%
%
%
%
%                    So Jos, 31 de julho de 2008
%
%-------------------------------------------------------------------------%

% Garantindo que a porta serial no est ocupada
try
	delete(serialUm)
end
clear all; clc;

global log_tela;
global fidlog;
global contexto;
global conectado;
global tempo_pausa;
global contexto_a_rejeitar;
	
% Adicionando o caminho dos programas referentes ao tratamento da imagem
addpath '..\Imagem';

disp('=======================================================================')
disp('====================== INICIO DO PROGRAMA =============================')
disp('=======================================================================')

% Conta o nmero de vezes que o prograa foi reiniciado
conta_inicios = 0;
while true
	
	% Tempo em segundos que a aplicao ir aguardar em caso de erros
	tempo_pausa = 300;

	conta_inicios = conta_inicios + 1;
	
	% O programa salva as mensagens de log em arquivo. Caso a varivel a seguir
	% esteja habilitada, ele tambm mostrar todas as mensagens na tela.
	% Mensagens importantes sempre so exibidas na tela.
	log_tela = false;

	% O arquivo a seguir  usado para as mensagens de log
	fidlog = fopen(['EDGE2JAVA.' date '.log.txt'],'a+');

	% A funo imp() foi criada para permitir um melhor tratamento das mensagem
	% de log do programa
	imp(['=========================================== Execuo nmero ' num2str(conta_inicios)],0)
	
	%------------------------------- Configurando as variveis do programa
	imp('Configurando as variaveis do programa',1)

	% Operadora do carto SIM utilizado
	operadora = 'CLARO';
    
    % Porta TCP utilizada no servidor
    porta = 9999;
    
	% Telefone que receber as imagens. O nmero  necessrio para o envio do
	% SMS
	tlfn = '4899577089';  % Neto................Nokia 6111...........< >....NOK
	tlfn = '4891496939';  % Jonatan.............LG mx8000............< >....NOK
	tlfn = '4899648005';  % Sandro..............Nokia <     >........< >....NOK
	tlfn = '4888166314';  % Fernando (daiana)...<              >.....Claro..NOK
	tlfn = '4896311048';  % Fabrcio (GSM)......Nokia 5310...........TIM....NOK
	tlfn = '4896195901';  % Patrick.............Motorola c650........TIM....NOK
	tlfn = '4899219766';  % Cara LAB Alunos.....Motorola v3..........TIM....NOK
	tlfn = '4896069769';  % Secretria * bunn...Motorola v3..........TIM....NOK
	tlfn = '4891345827';  % Fabrcio (CDMA).....Nokia 6265...........VIVO...NOK
	tlfn = '4896273435';  % Diego...............Nokia 3120...........TIM....NOK
	tlfn = '4884197444';  % Rodrigo Ramiro......LG atom mg110B.......BrT....NOK - Recebeu mas no conseguiu ler a mensagem
	tlfn = '4884076696';  % Claudecir...........SonyEricsson w900....BrT.....OK
	tlfn = '4884090978';  % Cesar...............Motorola z3..........< >....< >
	tlfn = '4899270977';  % Alex................Intelbras m500.......< >....< >
	tlfn = '4899493372';  % Amigo irmo diego...Motorola a1200.......< >.....OK
	tlfn = '4899873341';  % Felipe..............SonyEricsson w300i...< >.....OK
	tlfn = '4799039184';  % Z Paulo............Samsung d820.........< >.....OK
	tlfn = '4899277518';  % PB..................SonyEricsson w200i...TIM.....OK
	tlfn = '4884118666';  % Rodrigo.............LG MG160b............BrT.....OK
	tlfn = '4888121603';  % Daiana..............Motorola w175........Claro...OK
	tlfn = '4884211607';  % Moecke 2............Siemens c75..........BrT.....OK
	tlfn = '4899772757';  % Farleir.............Intelbras a6.........TIM.....OK
	tlfn = '4884157202';  % Nathalie............LG MG160b............Claro..NOK
	tlfn = '4891466625';  % Cleiber.............SonyEricsson w200i.VIVO GSM..OK
	tlfn = '4884121331';  % Moecke..............SonyEricsson w200i...BrT.....OK
	tlfn = '4888054778';  % Cleimar.............Nokia 5200...........Claro...OK
	tlfn = '4888219958';  % Cleimar.............Nokia 5200...........Claro...OK
	tlfn = '4884041231';  % Moecke nosso........Vrios...............BrT.....OK

	% Usamos a funo preencheZero para preencher o vetor com um valor
	% qualquer. Isto iguala o tamanho de todas as strings, permitindo a sua
	% colocao numa matriz
    cmd1 = {preencheZero('at+ipr=57600'),...
        preencheZero('at\q3'),...
        preencheZero('at+cmee=2'),...
        preencheZero('at+cops=0'),...
        preencheZero('at+cgreg=2'),...
        preencheZero('at^sics=5,conType,GPRS0'),...
        };
    % Existem diferenas de configurao dependendo da operadora utilizada.
    % Aqui, diferenciamos esta configurao.
    if strcmpi(operadora,'TIM')
        cmd1 = {cmd1{:},...
            preencheZero('at^sics=5,apn,tim.br'),...
            preencheZero('at^sics=5,user,tim'),...
            };
    elseif strcmpi(operadora,'CLARO')
        cmd1 = {cmd1{:},...
            preencheZero('at^sics=5,apn,claro.com.br'),...
            };
    elseif strcmpi(operadora,'BRT')
        cmd1 = {cmd1{:},...
            preencheZero('at^sics=5,apn,brt.br'),...
            preencheZero('at^sics=5,user,brt'),...
            preencheZero('at^sics=5,passwd,brt'),...
            };
    end
    cmd1 = {cmd1{:},...
        preencheZero('at^sics=5,passwd,tim'),...
        preencheZero('at^siss=0,srvType,Socket'),...
        preencheZero('at^siss=0,alphabet,0'),...
        preencheZero('at+cscs="GSM"'),...
        preencheZero(['at^siss=0,address,socktcp://listener:' num2str(porta)]),...
		preencheZero('at^siss=0,conId,5'),...
		preencheZero('at^siso=0'),...
		preencheZero('at^moni'),...
        };
	
	cmd2 = 'at^siso=';

	%--------------------------------------------- Configurando a aquisio
	imp('Configurando a aquisio do vdeo',1)
	ConfiguraCamera;

	%-------------------------------------- Configurando trmino da captura
	% O trmino da captura das imagens ser dado quando for apertada a tecla
	% 'q'. Para capturar a tecla pressionada, foi usado o artifcio do key
	% catching das figuras no MatLab. Ao pressionar uma tecla qualquer, o valor
	%  atribudo ao atributo 'CurrentCharacter' do objeto figura. Assim, basta
	% monitorar este valor at o pressionamento da tecla definida.
	imp('Configurando trmino da captura do vdeo',1)
	hf = figure(1);
	set(hf,'Units','Normalized','Position',[1.1 1.1 .2 .1], ...
		'Menubar','None','IntegerHandle','On','NumberTitle','Off', ...
		'Name','EDGE2JAVA','Resize','on','HandleVisibility','off');
	drawnow

	%----------------------------------------------------- Configura serial
	imp('Configurando a interface serial',1)
	configuraSerial;

	%------------------------------------------------- Enviando os comandos
	% O loop a seguir usa cada um dos comandos atribudos  varivel cmd1 para
	% configurar o mdulo. Aps este bloco, o mdulo estar pronto para receber
	% conexes de clientes TCP.
	imp('Configurando o mdulo',1)
	for R = 1:size(cmd1,2)
		imp(['Entrando na funo Envia_cmd(serialUm,cmd1{' num2str(R) '});'],2)
		Envia_cmd(serialUm,cmd1{R});
		[dados,cod] = Recebe_retorno(serialUm);
		% Se recebeu a tecla de parada
		if cod == 60
            imp('Parando a execuo do programa.',1)
            libera_Instancia(serialUm,objeto,hf);
            return;
        % Seno, se chegou qualquer coisa diferente de OK, abandona o loop
        elseif cod ~= 0
            break;
		end
		% Na ltima iterao, incrementa o valor de R. Isto  usado na
		% deteco de um erro, j que se nenhum erro ocorreu, quer dizer
		% que o R terminar com o valor "size(cmd1,2) + 1"
		if R == size(cmd1,2)
			R = R + 1;
		end
	end
	% Aqui, testa se o lao foi interrompido. Se for, aguarda alguns
	% instantes, desliga o mdulo e reinicia o loop principal do programa
	if R ~= (size(cmd1,2) + 1)
		imp('Reiniciando a aplicao',1)
		pause(tempo_pausa);
		libera_Instancia(serialUm,objeto,hf);
		continue;
	end

	%----------------------------------------------- Lendo o IP do servidor
	% Aps o registro do mdulo na rede EDGE, um IP  obtido. A funo a
	% seguir executa alguns comandos e filtros para descobrir o IP.
    imp('Lendo o IP obtido pelo mdulo',1)
	IP = Pega_IP(serialUm);
	if IP == 'q'
		imp('Saindo do programa',1)
		libera_Instancia(serialUm,objeto,hf);
		return;
	elseif isempty(IP)
		imp('Reiniciando a aplicao',1)
		pause(tempo_pausa);
		libera_Instancia(serialUm,objeto,hf);
		continue;
	end
	imp(['IP encontrado: ' IP],2)

	%--------------------------------------- Enviando o SMS  unidade mvel
	% Para avisar o usurio da ocorrncia de um evento, "acordando" a aplicao
	% Java na unidade mvel, utiliza-se uma mensagem SMS. Nesta mensagem,
	% formada no formato padro PDU (GSM 03.40) duas informaes importantes
	% so informadas:
	% * A porta de acesso  aplicao Java - Atravs do Push Registry, 
	% possvel registrar a aplicao, dizendo ao celular que quando uma
	% mensagem SMS endereada  determinada porta chegar, a aplicao dever
	% ser iniciada
	% * O IP de acesso ao servidor TCP - No corpo da mensagem o IP  informado.
	% A aplicao Java iniciada receber este IP e conectar o socket
	imp('Enviando o SMS',1);
	dados = Envia_sms(serialUm,tlfn,IP);
	if dados == 'q'
		imp('Saindo do programa',1)
		libera_Instancia(serialUm,objeto,hf);
		return;
	elseif isempty(dados)
		imp('Reiniciando a aplicao',1)
		pause(tempo_pausa);
		libera_Instancia(serialUm,objeto,hf);
		continue;
	end

	% Inicialmente dizemos que no existe ningum conectado no sistema,
	% quando algum se conectar, passaremos esta varivel para true. Isto 
	% usado para a desconexo de um cliente
	conectado = false;
	% Conta as conexes realizadas. Devido  limitaes do mdulo (Ver
	% deletando conexes), aps 4 conexes o mdulo ser reiniciado e um
	% novo IP ser obtido
	num_conexao = 0;
	while true
		
		num_conexao = num_conexao + 1;
		% Se exstirem quatro conexes ativas
		if num_conexao == 4
			% Sai do lao para reiniciar o modulo
			imp('Limite de conexes atingido. Reiniciando o programa.',1)
			break;
		end
		
		%%------------------------------------ Aguardando pedido de conexo
		imp(['Aguardando pedido de conexo de um cliente [' num2str(num_conexao) ']. IP: ' IP],1)
		contexto = Recebe_pedido_cnx(serialUm,1);
		% Passa a varivel para true, indicando que existe uma conexo
		% sendo tratada
		conectado = true;
		if contexto == 'q'
			imp('Saindo do programa',1)
			libera_Instancia(serialUm,objeto,hf);
			return;
		elseif isempty(contexto)
			imp('Reiniciando a aplicao',1)
			pause(tempo_pausa);
			break;  % Este break cair no libera_instncia() no fim do programa. Logo aps o lao ser reiniciado
		end;
		imp(['Recebido pedido, direcionado ao contexto: ' contexto],0)

		%----------------------------------------------- Aceitando o pedido
		imp('Aceitando o pedido',1)
		Envia_cmd(serialUm,[cmd2 contexto]);
		[dados,cod] = Recebe_retorno(serialUm);
        % Caso no existam conexes ativas
		if ~conectado
			% Reinicia o loop
			imp('Ningum conectado, reiniciando o loop',1)
			continue;
		end
		% Se recebeu a tecla de parada
        if cod == 60
            imp('Parando a execuo do programa.',1)
            libera_Instancia(serialUm,objeto,hf);
            return;
        % Seno, se chegou qualquer coisa diferente de OK
        elseif cod ~= 0
			imp(['Mensagem de cdigo ' num2str(cod) ' recebida. Aguardando alguns instantes e reiniciando a aplicao.'],1)
			pause(tempo_pausa);
			break;  % Este break cair no libera_instncia() no fim do programa. Logo aps o lao ser reiniciado
        end

		imp('Aguardando a mensagem de socket pronto para receber mensagens',0)
		[dados,cod] = Recebe_retorno(serialUm);
        % Caso no exista conexes ativas
		if ~conectado
			% Reinicia o loop
			imp('Ningum conectado, reiniciando o loop',1)
			continue;
		end
		% Se recebeu a tecla de parada
        if cod == 60
            imp('Parando a execuo do programa.',1)
            libera_Instancia(serialUm,objeto,hf);
            return;
        % Seno, se chegou qualquer coisa diferente de OK
        elseif cod ~= 40
			imp(['Mensagem de cdigo ' num2str(cod) ' recebida. Aguardando alguns instantes e reiniciando a aplicao.'],1)
			pause(tempo_pausa);
			break;  % Este break cair no libera_instncia() no fim do programa. Logo aps o lao ser reiniciado
        end


		%------------------------------------------------ Enviando a Figura
		imp('Enviando as imagens',1)
        
        % Conta as figuras enviadas
		num_fig_env = 0;

		while true;
			
			num_fig_env = num_fig_env + 1;
			%------------------------------------------------- Captura
			% D o start  captura do vdeo
			trigger(objeto);
			% Pega o frame da memria
			imp(['Capturando a imagem nmero ' num2str(num_fig_env)],2)
			data2 = getdata(objeto);
			% Subamostrando
			data(:,:,:) = data2(1:3:size(data2,1),1:3:size(data2,2),:);
			% Libera a memria
			flushdata(objeto);
			%------------------------------------------------- Codificao
			% Converte para jpeg
			imp(['Convertendo para JPEG a imagem nmero'  num2str(num_fig_env)],2)
			datajpeg = BMP2JPEG(data);
			%------------------------------------------------- Transmisso
			% Transforma o vetor numrico numa string
			datajpeg = num2str(datajpeg,'%c');
			% Envia a imagem ao outro lado
			imp(['Enviando a imagem nmero ' num2str(num_fig_env)],1)
			dados = Envia_figura(serialUm,datajpeg,contexto);
            if ~conectado
                imp('Ningum conectado, reiniciando o loop de espera de conexo.',1)
                break;
			end
			if dados == 'q'
				imp('Parando a execuo do programa.',1)
				libera_Instancia(serialUm,objeto,hf);
				return;
			elseif isempty(dados)
				imp('Reiniciando a aplicao.',1)
				% Faz isso para reiniciar toda a aplicao. Ao sair do
				% loop, a execuo cair no "if conectado" e reiniciar
				% todo o programa
				conectado = true;
				break;
			end
			imp(['Imagem nmero ' num2str(num_fig_env) ' enviada.'],1)

		end %-------------------------- fim do bloco de transmisso das imagens
		
		imp('Terminada a transmisso do bloco de imagem, aguardando nova conexo',1)

		% Se chegou aqui quer dizer que no existe ningum conectado. Se
		% tiver algum, sai do lao e reinicia o programa
        if conectado
			imp('Existe algum conectado onde no poderia existir, reiniciando o programa',1)
			break;
        end

		
	end %---------------------------------------------- fim do bloco das conexes
	
	%% Desligando o modulo
	libera_Instancia(serialUm,objeto,hf);
end