%
%                              Copyright 2008 Cleimar Jos Salvador, 
%						                      Diego da Silva de Medeiros, 
%						                      Fabrcio Emydio da Silva, 
%						                      Patrick Hedlund Rosa, 
%						                      Marcos Moecke, 
%						                      Mario de Noronha Neto
%
%
%    This file is part of Edge2javaTX.
%
%    Edge2javaTX is free software: you can redistribute it and/or modify
%    it under the terms of the GNU General Public License as published by
%    the Free Software Foundation, either version 3 of the License, or
%    (at your option) any later version.
%
%    Edge2javaTX is distributed in the hope that it will be useful,
%    but WITHOUT ANY WARRANTY; without even the implied warranty of
%    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%    GNU General Public License for more details.
%
%    You should have received a copy of the GNU General Public License
%    along with Edge2javaTX. If not, see <http://www.gnu.org/licenses/>.
%

function dados = Envia_figura(serialUm,fig_jpeg,contexto)

% Caso a figura tenha mais que 'L' bytes, ela ser quebrada em vrias
% partes. Isto se deve ao fato do mdulo ter entrada limitada.
L = 1400;

global conectado;

% Enviaremos primeiramente, 15 bytes indicando o nmero de caracteres que
% sero enviados na imagem. Este nmero ir em forma de string, sendo
% preenchido com zeros  esquerda caso ele no ocupe todos os caracteres.
% Exemplo, para uma imagem com 5234 bytes, o cabealho ser o seguinte:
% 000000000005234
imp('Criando o cabealho do protocolo',0)
header = sprintf('%015d',size(fig_jpeg,1));

imp(['Enviando o cabealho do protocolo: ' header],0)
dados = Envia_dados(serialUm,header,contexto);
if ~conectado
    imp('Socket no conectado, saindo da funo Envia_figura.',1);
	return;
end
if dados == 'q'
	imp('Saindo da funo Envia_figura.',1)
	return;
elseif isempty(dados)
	imp('Saindo da funo Envia_figura.',1)
	return;
end


% As imagens consistem num vetor, com valores de 0 a 255. Como o mdulo
% utiliza a tabela ASCII para enviar os dados, alguns valores, como o 17 a
% 20, so definidos na tabela como controle de fluxo. Decidimos tomar como
% soluo converter os bytes para o formato hexadecimal, limitando os
% caracteres aos valores de 1 a 9, de A a F. Assim, cada valor inteiro 
% representado por dois caracteres hexa, porm, evitamos o travamento do
% mdulo.
imp('Convertendo a figura para o formato hexadecimal',0)
fig_hex = '';
for R = 1:size(fig_jpeg,1)
	fig_hex = [fig_hex num2str(dec2hex(fig_jpeg(R),2))];
end

imp('Enviando os dados',0)

% ------------------------------------------------------------
% Baseado no valor de 'L', calculamos o nmero de vetores ao qual a imagem
% ser quebrada.
Loops = ceil(size(fig_hex,2)/L) - 1;
imp(['Tamanho da imagem: ' num2str(size(fig_hex,2))],2)
imp(['Nmero de loops: ' num2str(Loops)],2)

% O lao a seguir envia cada um dos vetores em que a imagem foi quebrada.
for R = 1 : Loops

	imp(['Loop numero ' num2str(R)],2)
	inicio = 1 + L*(R - 1);
	final = L + L*(R - 1);
	imp(['Incio: ' num2str(inicio) 9 'Final: ' num2str(final)],0)
	d = fig_hex(inicio:final);
	imp(['Tamanho obtido: ' num2str(size(d,2))],0)
	dados = Envia_dados(serialUm,d,contexto);
    if ~conectado
        imp('Socket no conectado, saindo da funo Envia_figura.',1);
        return;
	end
	if dados == 'q'
		imp('Saindo da funo Envia_figura.',1)
		return;
	elseif isempty(dados)
		imp('Saindo da funo Envia_figura.',1)
		return;
	end
	
end

% A ltima parte da imagem no tem uma diviso igual  das outras, sendo
% tratada fora do lao
imp('Ultima parte',0)
inicio = 1 + L*Loops;
final = size(fig_hex,2);
imp(['Incio: ' num2str(inicio) 9 'Final: ' num2str(final)],0)
df = fig_hex(inicio:final);
imp(['Tamanho obtido: ' num2str(size(df,2))],0)

% Mesmo sendo muito difcil,  possvel que a imagem tenha um tamanho
% divisvel por 'L'. Se for assim, descarta o envio da ltima parte
if size(df,2) ~= 0
	dados = Envia_dados(serialUm,df,contexto);
    if ~conectado
        imp('Socket no conectado, saindo da funo Envia_figura.',1);
        return;
    end
	if dados == 'q'
		imp('Saindo da funo Envia_figura.',1)
		return;
	elseif isempty(dados)
		imp('Saindo da funo Envia_figura.',1)
		return;
	end
end

